local jkHouses = ...

jkHouses:registerBehaviorTreeNode({
    Name = "MY_CUSTOM_TEST_NODE",
    VariableList = {
		Var1 = "BEHAVIOR_TREE_DATA_AGENT",
		Var2 = "BEHAVIOR_TREE_DATA_WAIT",
		Var3 = "BEHAVIOR_TREE_DATA_LOCATION",
		Var5 = "BEHAVIOR_TREE_DATA_LOOP",
		VillageLocation = "BEHAVIOR_TREE_DATA_LOCATION",
		TransportData = "BEHAVIOR_TREE_DATA_RESOURCE_TRANSPORT",
		WorkstationSetupData = "BEHAVIOR_TREE_DATA_WORKSTATION_SETUP"
    },
    Init = function(self, instance)
		jkHouses:log("INIT!")
    end,
    Update = function(self, level, instance)
		jkHouses:log("UPDATE!")
		return self:updateFunc(level, instance)
    end,
    Finish = function(self, instance)
		jkHouses:log("FINISH!")
    end,
	updateFunc = function(self, level, instance)
		jkHouses:log("UPDATE FUNC!")

		level:getComponentManager("COMP_WORKPLACE_TAX_OFFICE"):getAllComponent():forEach(function (cmp)
			-- if cmp.AssetBuilding.Name == "VILLAGE_CENTER" then
			-- 	self.VillageLocation:setDestination(cmp:getOwner())

			-- 	jkHouses:log("FOUND DA VILLAGE CENTER" .. tostring(cmp:getOwner()))
			-- 	jkHouses:log("FOUND DA VILLAGE CENTER" .. tostring(cmp:getOwner().InitialInventory))
			-- -- end
			-- jkHouses:log(tostring(cmp:getOwner()))
		end)
		jkHouses:log("Agent data: " .. tostring(self.Var1))
		local workplace = self.Var1.Agent:getOwner():getEnabledComponent("COMP_VILLAGER"):getJobInstance().Workplace
		jkHouses:log("Agent workplace: " .. tostring(workplace.depositTaxesCollected))

		workplace:depositTaxesCollected("GOLD_COINS", 237)
		-- jkHouses:log(tostring(workplace.PendingProductionCount))
		-- workplace.PendingProductionCount = 239
		-- jkHouses:log("WK SETUP: " .. tostring(self.WorkstationSetupData))
		-- jkHouses:log("Wait data: " .. tostring(self.Var2))
		-- jkHouses:log("Location data: " .. tostring(self.Var3))
		-- jkHouses:log("Loop data: " .. tostring(self.Var5))
		-- jkHouses:log("INSTANCE: " .. tostring(instance))

		-- self.TransportData = {}
		-- self.TransportData.TransportSetup = self.WorkstationSetupData.WorkstationSetup
		-- self.TransportData.Destination = self.VillageLocation
		-- self.TransportData.From = workplace

		-- jkHouses:log("T DATA: " .. tostring(self.TransportData))

		return BEHAVIOR_TREE_NODE_RESULT.TRUE
	end,
})

jkHouses:registerBehaviorTree({
	Id = "MY_COLLECTOR_BEHAVIOR",
	VariableList = {
		{
			Name = "VillageLocation",
			DataType = "BEHAVIOR_TREE_DATA_LOCATION",
			IsPublic = true
		},
		{
			Name = "AgentData",
			DataType = "BEHAVIOR_TREE_DATA_AGENT", 
			IsPublic = true,
			InitialValue = {} -- Optional if empty, leaves the default values (if any)
		},
		{
			Name = "DoJobTimer",
			DataType = "BEHAVIOR_TREE_DATA_WAIT",
			IsPublic = false,
			InitialValue = {
				TimeToWait = 3,
				Animation = AGENT_ANIMATION.GATHER,
				SetIdleAfterWait = false,
			}
		},
		{
			Name = "WorkplacePosition",
			DataType = "BEHAVIOR_TREE_DATA_LOCATION",
			IsPublic = false,
			InitialValue = {
				CanNavigateOnGround = true,
				CanNavigateOnWater = false,
				IsSetOrientationOnDestination = true,
			}
		},
		{
			Name = "WorkstationSetupData",
			DataType = "BEHAVIOR_TREE_DATA_WORKSTATION_SETUP",
			IsPublic = true,
		},
		{
			Name = "TransportData",
			DataType = "BEHAVIOR_TREE_DATA_RESOURCE_TRANSPORT",
			IsPublic = true
		},
		{
			Name = "WorkLoop",
			DataType = "BEHAVIOR_TREE_DATA_LOOP",
			IsPublic = true,
			InitialValue = {
				LoopCount = 2,
				Duration = 0,
				IsInfinite = false,
				IsDuration = false,
			}
		},
        -- {
        --     Name = "ResourceProducedList"
        -- }
	},
	Root = {
		Name = "WorkingGlobalSequencer",
		Type = "SEQUENCER",
		Children = {
			{
				Name = "NeedFilledSelector",
				Type = "SELECTOR",
				Children = {
					{
						Name = "NeedFilledInverter",
						Type = "INVERTER",
						Child = {
							Name = "IsMyNeedFilled",
							Type = "IS_WORKPLACE_NEED_RESOURCE",
							AgentData = "AgentData",
						}
					},
				},
			},
			{
				Name = "WorkLoopRepeater",
				Type = "REPEAT",
				RepeatData = "WorkLoop",
				Child = {
					Name = "WorkLoopSequencer",
					Type = "SEQUENCER",
					Children = {
						{
							Name = "X",
							Type = "ENABLE_PATH_TRACING",
							AgentData = "AgentData"
						},
						{
							Name = "SetupWork",
							Type = "SETUP_WORK",
							AgentData = "AgentData",
							TimeToWait = "DoJobTimer",
							WorkPosition = "WorkplacePosition",
						},
						{
							Name = "SetupWorkstationSetup",
							Type = "SET_WORKSTATION_SETUP",
							AgentData = "AgentData",
							WorkstationSetupData = "WorkstationSetupData"
						},
						{
							Name = "GoToResource",
							Type = "GO_TO",
							AgentData = "AgentData",
							Destination = "WorkplacePosition",
							BuildingPathType = "",
							AnimationData = "",
							AnimationSpeedMultiplier = "",
						},
						{
							Name = "CUSTOM_NODE_INSTANCE",
							Type = "MY_CUSTOM_TEST_NODE",
							Var1 = "AgentData",
							Var2 = "DoJobTimer",
							Var3 = "WorkplacePosition",
							Var5 = "WorkLoop",
							VillageLocation = "VillageLocation",
							TransportData = "TransportData",
							WorkstationSetupData = "WorkstationSetupData"
						},
						{
							Name = "GettingXp",
							Type = "GIVE_JOB_XP",
							AgentData = "AgentData",
							ShouldReceiveXp = "",
						},
						-- {
						-- 	Name = "MoveDaGold",
						-- 	Type = "BEHAVIOR_TRANSPORT",
						-- 	AgentData = "AgentData",
						-- 	TransportData = "TransportData"
						-- }
						-- {
						-- 	Name = "GoToVillageCenter",
						-- 	Type = "GO_TO",
						-- 	AgentData = "AgentData",
						-- 	Destination = "VillageLocation",
						-- 	BuildingPathType = "",
						-- 	AnimationData = "",
						-- 	AnimationSpeedMultiplier = "",
						-- },
					}
				}
			}
		}
	}
})